import java.io.*;
import java.util.*;

public class topcoder_al_Onlogn_set {
  static final int LogMaxN = 16;

  static class Game implements Comparable <Game> {
    long x, y;
    int k;
    Game (long xx, long yy) { 
      x = xx; 
      y = yy;
      k = LogMaxN;
      for (int i = 0; i < LogMaxN; i++) {
        long l1 = x & (-(1L << i));
        long l2 = (y ^ (1L << i)) & (-(1L << i));
        if (l1 == l2) {
          k = i;
          break;
        };
      };
    };
    public int compareTo (Game z) {
      if (k < z.k) return -1;
      if (k > z.k) return 1;
      if (y < z.y) return -1;
      if (y > z.y) return 1;
      if (x < z.x) return -1;
      if (x > z.x) return 1;
      return 0;
    };
    public String toString () {
      return x + " vs " + y + ": tour " + k;
    };
  };

  public static void main (String args []) throws Exception {
    BufferedReader in = new BufferedReader (new FileReader (new File ("topcoder.in")));
    PrintWriter out = new PrintWriter ("topcoder.out");
    StringTokenizer t = new StringTokenizer (in.readLine ());



    int k = Integer.parseInt (t.nextToken ());
    int n = Integer.parseInt (t.nextToken ());
    int m = Integer.parseInt (t.nextToken ());

    if (k < 1 || k > 60) throw new Exception ("invalid k");
    if (n < 0 || n > 1e5) throw new Exception ("invalid n");
    if (m < 1 || m > 1e5) throw new Exception ("invalid m");
    if (t.hasMoreTokens ()) throw new Exception ("too many tokens");

    Game [] p1 = new Game [n + 1];
    for (int i = 0; i < n; i++) {
      t = new StringTokenizer (in.readLine ());
      long a = Long.parseLong (t.nextToken ());
      long b = Long.parseLong (t.nextToken ());
      if (t.hasMoreTokens ()) throw new Exception ("too many tokens");
      --a; --b;
      if (a < 0 || a >= 1L << k || b < 0 || b >= 1L << k || a == b) throw new Exception ("invalid a or b");

      p1[i] = new Game (a, b);
    };
    p1[n] = new Game (0, 1L << k);
    Arrays.sort (p1);

    //for (Game p : p1) System.out.println (p);


    for (Game p : p1)
      if (Arrays.binarySearch (p1, new Game (p.y, p.x)) >= 0)
        throw new Exception ("condradictionary pair");

    long [] qu = new long [m];
    t = new StringTokenizer (in.readLine ());
    for (int i = 0; i < m; i++) {
      qu[i] = Long.parseLong (t.nextToken ());
      --qu[i];
      if (qu[i] < 0 || qu[i] >= 1L << k) throw new Exception ("invalid query");
      if (i > 0 && qu[i] <= qu[i - 1]) throw new Exception ("ascending order required");
    };

    if (t.hasMoreTokens ()) throw new Exception ("End of line expected");
    if (in.ready ()) throw new Exception ("End of file expected");

    int ans [] = new int [m];

    Arrays.fill (ans, k);


    TreeSet <Long> off = new TreeSet <Long> ();

    int r = 0;

    ArrayList <Long> tmp = new ArrayList <Long> ();

    for (int i = 0; i < n && p1[i].k < LogMaxN; i = r) {
      if (i > 0 && p1[i - 1].k != p1[i].k) {
        off.addAll (tmp);
        tmp = new ArrayList <Long> ();
      };
      long b = p1[i].x & (-(1L << p1[i].k)), e = b + (1L << p1[i].k);

      //System.out.println (i + " " + p1[i]);

      Iterator <Long> tt = off.tailSet (b).iterator ();

      //System.out.println ("decision on " + p1[i].y + ", tour " + p1[i].k + ": analyzing from " + b + " to " + e);

      long cnext = -1;
      
      if (tt.hasNext ()) cnext = tt.next ();

      while (b < e) {
        int inc = 0;
        if (p1[r].y == p1[i].y && b == p1[r].x) {++r; ++inc;};
        if (b == cnext) {
          ++inc;
          if (tt.hasNext ()) cnext = tt.next (); else cnext = -1;
        };
        //System.out.println (inc);
        if (inc == 0) break;
        ++b;
      };
      //System.out.println (b + " " + e + " " + off);
      if (b == e) {
        tmp.add (p1[i].y);
        int pos = Arrays.binarySearch (qu, p1[i].y);
        if (pos >= 0 && ans[pos] == k) ans[pos] = p1[i].k + 1;
      };
      while (p1[r].y == p1[i].y) ++r;
    };

    for (int i = 0; i < m; i++) out.print (ans[i] + " ");
    out.close ();
  };
};

