#define _CRT_SECURE_NO_DEPRECATE

#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>

using namespace std;

const int nmax = 200001;
const int mmax = 100001;

vector < long long > d[nmax];
long long use[nmax];
long long dead[nmax];
int best[nmax];
int n, k;

int m;
long long data[mmax];
long long x[nmax], y[nmax];

void init() {
    scanf("%d%d%d", &k, &n, &m);
    int total = 0;
    for (int i = 0; i < n; ++i) {
        scanf("%I64d%I64d", &x[i], &y[i]);
        use[total++] = --x[i];
        use[total++] = --y[i];
    }
    for (int i = 0; i < m; ++i) scanf("%I64d", &data[i]), data[i]--;

    sort(use, use + total);
    total = unique(use, use + total) - use;

    for (int i = 0; i < n; ++i) {
        int i1 = lower_bound(use, use + total, x[i]) - use;
        int i2 = lower_bound(use, use + total, y[i]) - use;
        d[i2].push_back(x[i]);
    }
    n = total;
    for (int i = 0; i < n; ++i) sort(d[i].begin(), d[i].end());
}

void solve() {
    long long left, right, l, r;
    int addlen, len = 0;
    memset(best, 0, sizeof(best));

    for (int step = 0, size = 1; step + 1 < k; ++step, size <<= 1) {
        addlen = 0;
        for (int i = 0; i < n; ++i) if (best[i] == 0) {
            if (size > n) continue;
            left = (use[i] >> step) << step;
            if (use[i] & size) left -= size; else left += size;
            right = left + size - 1;
            int cnt1 = upper_bound(dead, dead + len, right) - lower_bound(dead, dead + len, left);
            int cnt2 = 0;

            l = lower_bound(d[i].begin(), d[i].end(), left) - d[i].begin();
            r = upper_bound(d[i].begin(), d[i].end(), right) - d[i].begin();
            for (int j = l; j < r; ++j) {
                if (!binary_search(dead, dead + len, d[i][j])) cnt2++;
            }

            if (cnt1 + cnt2 == size && cnt2 > 0) {
                best[i] = step + 1;
                dead[len + addlen++] = use[i];
            }
        }
        len += addlen;
        sort(dead, dead + len);
    }
    for (int i = 0; i < n; ++i) {
        if (best[i] == 0) best[i] = k;
//        cerr << "best[" << i << "] = " << best[i] << endl;
    }


}

void writeanswer() {
    for (int i = 0; i < m; ++i) {
        if (i > 0) printf(" ");
        int index = lower_bound(use, use + n, data[i]) - use;
        if (index < n && use[index] == data[i]) printf("%d", best[index]); else printf("%d", k);
    }
}

int main() {
    freopen("topcoder.in", "rt", stdin);
    freopen("topcoder.out", "wt", stdout);

    init();
    solve();
    writeanswer();
    
    return 0;
}
