//solution with array of size 2^18
//count possible competitors for every person in every tour, and subtract competitors that win him

{$apptype console}
{$r+,q+,s+,o-}

uses sysutils;

const maxn = 100000;
      maxk = 60;

function gettour(a, b: int64): longint;
var j: longint;
begin
  j := 60;
  while (j > 0) and ((a xor b) shr (j - 1) = 0) do
    dec(j);
  result := j;
end;

var p, q: int64;
    i, j, l, n, k: longint;
    a, b: array[0..maxn]of int64;
    fk: array[0..maxk]of longint;
    nk: array[0..maxn]of longint;
    alive: array[0..1 shl 18]of boolean;
    cnum, num, count: array[0..1 shl 18]of longint;

function get(x: int64; h: longint): longint;
var s: int64;
    i, r, v: longint;
begin
  s := (x shr h) shl h;
  r := (1 shl h) - 1;
  fillchar(alive, sizeof(alive), true);
  for i := 0 to r do
    num[i] := i;

  for i := 1 to h do begin
    fillchar(cnum, sizeof(cnum), 0);
    for v := 0 to r do
      if alive[v] then
        inc(cnum[num[v]]);

    fillchar(count, sizeof(count), 0);
    for v := 0 to r do
      if num[v] mod 2 = 0 then
        count[v] := cnum[num[v] + 1]
      else
        count[v] := cnum[num[v] - 1];

    v := fk[i];
    while v > 0 do begin
      if (a[v] >= s) and (a[v] <= s + r) and (b[v] >= s) and (b[v] <= s + r) then
        if alive[longint(a[v] - s)] then
          dec(count[longint(b[v] - s)]);
      v := nk[v];
    end;

    for v := 0 to r do
      alive[v] := alive[v] and (count[v] > 0);
    for v := 0 to r do
      num[v] := num[v] shr 1;
    if not alive[longint(x - s)] then begin
      result := i;
      exit;
    end;
  end;
  result := h;
end;

begin
  reset(input, 'topcoder.in');
  rewrite(output, 'topcoder.out');

  read(p, q, k);
  assert((1 <= k) and (k <= maxk), 'wrong k');
  p := p - 1;
  q := q - 1;
  assert((0 <= p) and (p < int64(1) shl k), 'wrong p');
  assert((0 <= q) and (q < int64(1) shl k), 'wrong q');

  read(n);
  assert((0 <= n) and (n <= maxn));
  fillchar(fk, sizeof(fk), 0);
  for i := 1 to n do begin
    read(a[i], b[i]);
    a[i] := a[i] - 1;
    b[i] := b[i] - 1;
    assert((0 <= a[i]) and (a[i] < int64(1) shl k) and (0 <= b[i]) and (b[i] < int64(1) shl k) and (a[i] <> b[i]), 'wrong a or b');
    assert( not( ((a[i] = p) and (b[i] = q)) or ((a[i] = q) and (b[i] = p)) ) , 'equal to (p, q)');

    j := gettour(a[i], b[i]);

    nk[i] := fk[j];
    fk[j] := i;
  end;

  j := gettour(p, q);
  if j > 18 then 
    j := 18;
  i := get(p, j);
  l := get(q, j);
  if i > l then
    i := l;
  if i < j then
    writeln(0, ' ', i)
  else
    writeln(gettour(p, q));
end.